/*
 * Copyright (c) 2003, Adam Dunkels.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 * 3. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior
 *    written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * This file is part of the uIP TCP/IP stack
 *
 * $Id: telnetd.h,v 1.2 2006/06/07 09:43:54 adam Exp $
 *
 */
#ifndef __TELNETD_H__
#define __TELNETD_H__

#include "../misc/tel_tools.h"
#include "uipopt.h"


#ifdef __cplusplus
extern "C" {
#endif


#ifndef TELNETD_CONF_LINELEN_OUT
  #define TELNETD_CONF_LINELEN_OUT	CONF_LINELEN_OUT
  #define TELNETD_CONF_NUMLINES		CONF_NUMLINES   
#endif
#define TELNETD_CONF_LINELEN_IN		40
#ifndef TELNETD_CONF_NUMLINES
 #define TELNETD_CONF_NUMLINES		16
#endif

/** State of connection. */
typedef enum
{
  TEL_NOT_LOGGED,
  TEL_GET_USERNAME,
  TEL_USERNAME_OK,
  TEL_USER_OK
} TEL_SHELL_STATES;


/** Status of a telnet line. */
typedef struct
{
  char *lines[TELNETD_CONF_NUMLINES];	/**< Output buffer */	
  char buf[TELNETD_CONF_LINELEN_IN];	/**< Input buffer */
  char bufptr;				/**< ptr to input buffer */
  u8_t numsent;				/**< Number of sent 'lines' during last transmition.*/  
  u8_t shellstate;		/**< ::TEL_NOT_LOGGED -> ::TEL_USERNAME_OK -> ::TEL_USER_OK */
  u8_t UserIDX;			/**< Index to a table of users. */
  term_state TS;
} telnetd_state;



/** typedef telnetd_state uip_tcp_appstate_t; */

void telnetd_init(void);


#ifdef __cplusplus
 }
#endif

#endif /* __TELNETD_H__ */
