
//#include "typedfs.h"

/** Replacement for IPv4 checksum tailored for 32 bit architecture. */
static inline u16_t chksum(u16_t sum, const u8_t *data, u16_t len)
{  
  register u32_t acu = sum;
  const u8_t *last_byte;

  last_byte = data + len - 1;

  while(data < last_byte)	/* At least two more bytes */  
  {
    acu += *data++ << 8;
    acu += *data++;
  }

  if(data == last_byte)
  {
    acu += *data << 8;
  }
   
  acu = (acu & 0xFFFF) + (acu >> 16);	/* carry */
  if(acu & 0xFFFF0000)
  {
    acu = (acu & 0xFFFF) + 1;		/* carry caused carry */
  }

  /* Return sum in host byte order. */
  return acu;
}
